Index: src/sas/sascalc/dataloader/readers/cansas_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision 83b6408fbfaefa4819b955c697fef834d8f033f6)
+++ src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision 5f26aa48a5e34765d73c20fa10024d5319567854)
@@ -151,135 +495,112 @@
 
         # Generic values for the cansas file based on the version
-        cansas_defaults = CANSAS_NS.get(self.cansas_version, "1.0")
+        self.cansas_defaults = CANSAS_NS.get(self.cansas_version, "1.0")
         if schema_path == "":
-            schema_path = "{0}/sas/sascalc/dataloader/readers/schema/{1}".format\
-                (base, cansas_defaults.get("schema")).replace("\\", "/")
+            schema_path = "{0}/sas/sascalc/dataloader/readers/schema/{1}".format \
+                (base, self.cansas_defaults.get("schema")).replace("\\", "/")
 
         # Link a schema to the XML file.
         self.set_schema(schema_path)
-        return cansas_defaults
-
-    ## TODO: Test loading invalid CanSAS XML files and see if this works
-    ## TODO: Once works, try adding a warning that the data is invalid
-    def read(self, xml_file, schema_path=""):
-        """
-        Validate and read in an xml_file file in the canSAS format.
-
-        :param xml_file: A canSAS file path in proper XML format
-        """
-        # output - Final list of Data1D objects
-        output = []
-        # ns - Namespace hierarchy for current xml_file object
-        ns_list = []
-
-        # Check that the file exists
-        if os.path.isfile(xml_file):
-            basename = os.path.basename(xml_file)
-            _, extension = os.path.splitext(basename)
-            # If the file type is not allowed, return nothing
-            if extension in self.ext or self.allow_all:
-                # Get the file location of
-                cansas_defaults = self.load_file_and_schema(xml_file, schema_path)
-
-                # Try to load the file, but raise an error if unable to.
-                # Check the file matches the XML schema
-                try:
-                    if self.is_cansas(extension):
-                        # Get each SASentry from XML file and add it to a list.
-                        entry_list = self.xmlroot.xpath(
-                                '/ns:SASroot/ns:SASentry',
-                                namespaces={'ns': cansas_defaults.get("ns")})
-                        ns_list.append("SASentry")
-
-                        # If multiple files, modify the name for each is unique
-                        increment = 0
-                        # Parse each SASentry item
-                        for entry in entry_list:
-                            # Define a new Data1D object with zeroes for
-                            # x_vals and y_vals
-                            data1d = Data1D(numpy.empty(0), numpy.empty(0),
-                                            numpy.empty(0), numpy.empty(0))
-                            data1d.dxl = numpy.empty(0)
-                            data1d.dxw = numpy.empty(0)
-
-                            # If more than one SASentry, increment each in order
-                            name = basename
-                            if len(entry_list) - 1 > 0:
-                                name += "_{0}".format(increment)
-                                increment += 1
-
-                            # Set the Data1D name and then parse the entry.
-                            # The entry is appended to a list of entry values
-                            data1d.filename = name
-                            data1d.meta_data["loader"] = "CanSAS 1D"
-
-                            # Get all preprocessing events and encoding
-                            self.set_processing_instructions()
-                            data1d.meta_data[PREPROCESS] = \
-                                    self.processing_instructions
-
-                            # Parse the XML file
-                            return_value, extras = \
-                                self._parse_entry(entry, ns_list, data1d)
-                            del extras[:]
-
-                            return_value = self._final_cleanup(return_value)
-                            output.append(return_value)
-                    else:
-                        raise RuntimeError, "Invalid XML at: {0}".format(\
-                                                    self.find_invalid_xml())
-                except:
-                    # If the file does not match the schema, raise this error
-                    schema_path = "{0}/sas/sascalc/dataloader/readers/schema/cansas1d_invalid.xsd"
-                    invalid_xml = self.find_invalid_xml()
-                    invalid_xml = "\n\nThe loaded xml file does not fully meet the CanSAS v1.x specification. SasView " + \
-                                  "loaded as much of the data as possible.\n\n" + invalid_xml
-                    self.errors.add(invalid_xml)
-                    self.set_schema(schema_path)
-                    if self.is_cansas():
-                        output = self.read(xml_file, schema_path)
-                    else:
-                        raise RuntimeError, "%s cannot be read" % xml_file
-                return output
-        # Return a list of parsed entries that dataloader can manage
-        return None
-
-    def _final_cleanup(self, data1d):
+
+    def add_data_set(self):
+        """
+        Adds the current_dataset to the list of outputs after preforming final processing on the data and then calls a
+        private method to generate a new data set.
+
+        :param key: NeXus group name for current tree level
+        """
+
+        if self.current_datainfo and self.current_dataset:
+            self._final_cleanup()
+        self.data = []
+        self.current_datainfo = DataInfo()
+
+    def _initialize_new_data_set(self, parent_list=None):
+        """
+        A private class method to generate a new 1D data object.
+        Outside methods should call add_data_set() to be sure any existing data is stored properly.
+
+        :param parent_list: List of names of parent elements
+        """
+
+        if parent_list is None:
+            parent_list = []
+        x = np.array(0)
+        y = np.array(0)
+        self.current_dataset = plottable_1D(x, y)
+
+    def add_intermediate(self):
+        """
+        This method stores any intermediate objects within the final data set after fully reading the set.
+
+        :param parent: The NXclass name for the h5py Group object that just finished being processed
+        """
+
+        if self.parent_class == 'SASprocess':
+            self.current_datainfo.process.append(self.process)
+            self.process = Process()
+        elif self.parent_class == 'SASdetector':
+            self.current_datainfo.detector.append(self.detector)
+            self.detector = Detector()
+        elif self.parent_class == 'SAStransmission_spectrum':
+            self.current_datainfo.trans_spectrum.append(self.transspectrum)
+            self.transspectrum = TransmissionSpectrum()
+        elif self.parent_class == 'SAScollimation':
+            self.current_datainfo.collimation.append(self.collimation)
+            self.collimation = Collimation()
+        elif self.parent_class == 'aperture':
+            self.collimation.aperture.append(self.aperture)
+            self.aperture = Aperture()
+        elif self.parent_class == 'SASdata':
+            self._check_for_empty_resolution()
+            self.data.append(self.current_dataset)
+
+    def _final_cleanup(self):
         """
         Final cleanup of the Data1D object to be sure it has all the
         appropriate information needed for perspectives
-
-        :param data1d: Data1D object that has been populated
-        """
-        # Final cleanup
-        # Remove empty nodes, verify array sizes are correct
+        """
+
+        ## Append errors to dataset and reset class errors
+        self.current_datainfo.errors = set()
         for error in self.errors:
-            data1d.errors.append(error)
+            self.current_datainfo.errors.add(error)
         self.errors.clear()
-        numpy.trim_zeros(data1d.x)
-        numpy.trim_zeros(data1d.y)
-        numpy.trim_zeros(data1d.dy)
-        size_dx = data1d.dx.size
-        size_dxl = data1d.dxl.size
-        size_dxw = data1d.dxw.size
-        if data1d._xunit != data1d.x_unit:
-            data1d.x_unit = data1d._xunit
-        if data1d._yunit != data1d.y_unit:
-            data1d.y_unit = data1d._yunit
-        if size_dxl == 0 and size_dxw == 0:
-            data1d.dxl = None
-            data1d.dxw = None
-            numpy.trim_zeros(data1d.dx)
-        elif size_dx == 0:
-            data1d.dx = None
-            size_dx = size_dxl
-            numpy.trim_zeros(data1d.dxl)
-            numpy.trim_zeros(data1d.dxw)
-        return data1d
+
+        ## Combine all plottables with datainfo and append each to output
+        ## Type cast data arrays to float64 and find min/max as appropriate
+        for dataset in self.data:
+            if dataset.x is not None:
+                dataset.x = np.delete(dataset.x, [0])
+                dataset.x = dataset.x.astype(np.float64)
+                dataset.xmin = np.min(dataset.x)
+                dataset.xmax = np.max(dataset.x)
+            if dataset.y is not None:
+                dataset.y = np.delete(dataset.y, [0])
+                dataset.y = dataset.y.astype(np.float64)
+                dataset.ymin = np.min(dataset.y)
+                dataset.ymax = np.max(dataset.y)
+            if dataset.dx is not None:
+                dataset.dx = np.delete(dataset.dx, [0])
+                dataset.dx = dataset.dx.astype(np.float64)
+            if dataset.dxl is not None:
+                dataset.dxl = np.delete(dataset.dxl, [0])
+                dataset.dxl = dataset.dxl.astype(np.float64)
+            if dataset.dxw is not None:
+                dataset.dxw = np.delete(dataset.dxw, [0])
+                dataset.dxw = dataset.dxw.astype(np.float64)
+            if dataset.dy is not None:
+                dataset.dy = np.delete(dataset.dy, [0])
+                dataset.dy = dataset.dy.astype(np.float64)
+            np.trim_zeros(dataset.x)
+            np.trim_zeros(dataset.y)
+            np.trim_zeros(dataset.dy)
+            final_dataset = combine_data(dataset, self.current_datainfo)
+            self.output.append(final_dataset)
 
     def _create_unique_key(self, dictionary, name, numb=0):
         """
         Create a unique key value for any dictionary to prevent overwriting
-        Recurses until a unique key value is found.
+        Recurse until a unique key value is found.
 
         :param dictionary: A dictionary with any number of entries
@@ -294,14 +615,47 @@
         return name
 
-    def _unit_conversion(self, node, new_current_level, data1d, \
-                                                tagname, node_value):
+    def _get_node_value(self, node, tagname):
+        """
+        Get the value of a node and any applicable units
+
+        :param node: The XML node to get the value of
+        :param tagname: The tagname of the node
+        """
+        #Get the text from the node and convert all whitespace to spaces
+        units = ''
+        node_value = node.text
+        if node_value is not None:
+            node_value = ' '.join(node_value.split())
+        else:
+            node_value = ""
+
+        # If the value is a float, compile with units.
+        if self.ns_list.ns_datatype == "float":
+            # If an empty value is given, set as zero.
+            if node_value is None or node_value.isspace() \
+                                    or node_value.lower() == "nan":
+                node_value = "0.0"
+            #Convert the value to the base units
+            node_value, units = self._unit_conversion(node, tagname, node_value)
+
+        # If the value is a timestamp, convert to a datetime object
+        elif self.ns_list.ns_datatype == "timestamp":
+            if node_value is None or node_value.isspace():
+                pass
+            else:
+                try:
+                    node_value = \
+                        datetime.datetime.fromtimestamp(node_value)
+                except ValueError:
+                    node_value = None
+        return node_value, units
+
+    def _unit_conversion(self, node, tagname, node_value):
         """
         A unit converter method used to convert the data included in the file
         to the default units listed in data_info
 
-        :param new_current_level: cansas_constants level as returned by
-            iterate_namespace
-        :param attr: The attributes of the node
-        :param data1d: Where the values will be saved
+        :param node: XML node
+        :param tagname: name of the node
         :param node_value: The value of the current dom node
         """
@@ -310,13 +664,33 @@
         err_msg = None
         default_unit = None
-        if 'unit' in attr and new_current_level.get('unit') is not None:
+        if not isinstance(node_value, float):
+            node_value = float(node_value)
+        if 'unit' in attr and attr.get('unit') is not None:
             try:
                 local_unit = attr['unit']
-                if isinstance(node_value, float) is False:
-                    exec("node_value = float({0})".format(node_value))
-                unitname = new_current_level.get("unit")
-                exec "default_unit = data1d.{0}".format(unitname)
-                if local_unit is not None and default_unit is not None and \
-                        local_unit.lower() != default_unit.lower() \
+                unitname = self.ns_list.current_level.get("unit", "")
+                if "SASdetector" in self.names:
+                    save_in = "detector"
+                elif "aperture" in self.names:
+                    save_in = "aperture"
+                elif "SAScollimation" in self.names:
+                    save_in = "collimation"
+                elif "SAStransmission_spectrum" in self.names:
+                    save_in = "transspectrum"
+                elif "SASdata" in self.names:
+                    x = np.zeros(1)
+                    y = np.zeros(1)
+                    self.current_data1d = Data1D(x, y)
+                    save_in = "current_data1d"
+                elif "SASsource" in self.names:
+                    save_in = "current_datainfo.source"
+                elif "SASsample" in self.names:
+                    save_in = "current_datainfo.sample"
+                elif "SASprocess" in self.names:
+                    save_in = "process"
+                else:
+                    save_in = "current_datainfo"
+                exec "default_unit = self.{0}.{1}".format(save_in, unitname)
+                if local_unit and default_unit and local_unit.lower() != default_unit.lower() \
                         and local_unit.lower() != "none":
                     if HAS_CONVERTER == True:
@@ -345,8 +719,7 @@
         if err_msg:
             self.errors.add(err_msg)
-        node_value = "float({0})".format(node_value)
         return node_value, value_unit
 
-    def _check_for_empty_data(self, data1d):
+    def _check_for_empty_data(self):
         """
         Creates an empty data set if no data is passed to the reader
@@ -354,51 +727,16 @@
         :param data1d: presumably a Data1D object
         """
-        if data1d == None:
-            self.errors = set()
-            x_vals = numpy.empty(0)
-            y_vals = numpy.empty(0)
-            dx_vals = numpy.empty(0)
-            dy_vals = numpy.empty(0)
-            dxl = numpy.empty(0)
-            dxw = numpy.empty(0)
-            data1d = Data1D(x_vals, y_vals, dx_vals, dy_vals)
-            data1d.dxl = dxl
-            data1d.dxw = dxw
-        return data1d
-
-    def _handle_special_cases(self, tagname, data1d, children):
-        """
-        Handle cases where the data type in Data1D is a dictionary or list
-
-        :param tagname: XML tagname in use
-        :param data1d: The original Data1D object
-        :param children: Child nodes of node
-        :param node: existing node with tag name 'tagname'
-        """
-        if tagname == "SASdetector":
-            data1d = Detector()
-        elif tagname == "SAScollimation":
-            data1d = Collimation()
-        elif tagname == "SAStransmission_spectrum":
-            data1d = TransmissionSpectrum()
-        elif tagname == "SASprocess":
-            data1d = Process()
-            for child in children:
-                if child.tag.replace(self.base_ns, "") == "term":
-                    term_attr = {}
-                    for attr in child.keys():
-                        term_attr[attr] = \
-                            ' '.join(child.get(attr).split())
-                    if child.text is not None:
-                        term_attr['value'] = \
-                            ' '.join(child.text.split())
-                    data1d.term.append(term_attr)
-        elif tagname == "aperture":
-            data1d = Aperture()
-        if tagname == "Idata" and children is not None:
-            data1d = self._check_for_empty_resolution(data1d, children)
-        return data1d
-
-    def _check_for_empty_resolution(self, data1d, children):
+        if self.current_dataset == None:
+            x_vals = np.empty(0)
+            y_vals = np.empty(0)
+            dx_vals = np.empty(0)
+            dy_vals = np.empty(0)
+            dxl = np.empty(0)
+            dxw = np.empty(0)
+            self.current_dataset = plottable_1D(x_vals, y_vals, dx_vals, dy_vals)
+            self.current_dataset.dxl = dxl
+            self.current_dataset.dxw = dxw
+
+    def _check_for_empty_resolution(self):
         """
         A method to check all resolution data sets are the same size as I and Q
